(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
const devices = require("./lib/devices/devices");

class Decoder {
    constructor(type) {
        this.type = type;
        this.device = devices.initialize(type);
    }

    decode(payload) {
        if (this.device && (typeof payload === "string" || payload instanceof String)) {
            return this.device.decode(payload);
        } else if (!this.device) {
            return {
                result: null,
                error: `No decoder found for type: ${this.type}`,
            };
        } else {
            return {
                result: null,
                error: "Unsupported paylod type",
            };
        }
    }
}

exports.Decoder = Decoder;

},{"./lib/devices/devices":2}],2:[function(require,module,exports){

const devices = {
    "600-021": require("./types/600-021"),
    "600-022": require("./types/600-022"),
    "600-023": require("./types/600-023"),
    "600-024": require("./types/600-024"),
    "600-031": require("./types/600-031"),
    "600-032": require("./types/600-032"),
    "600-033": require("./types/600-033"),
    "600-034": require("./types/600-034"),
    "600-035": require("./types/600-035"),
    "600-036": require("./types/600-036"),
    "600-037": require("./types/600-037"),
    "600-038": require("./types/600-038"),
    "600-039": require("./types/600-039"),
    "600-232": require("./types/600-232"),
    "600-233": require("./types/600-233")
};


exports.initialize = (type) => {
    try {
        //const devicePath = "./types/" + type + ".js";
        //const deviceModule = require(devicePath); // for NodeJs
        const deviceModule = devices[type]; //For browser - not support dynamic require
        return new deviceModule.device();
    } catch (e) {
        //console.log("This device type is not supported", e);
        return null;
    }
};

},{"./types/600-021":3,"./types/600-022":4,"./types/600-023":5,"./types/600-024":6,"./types/600-031":7,"./types/600-032":8,"./types/600-033":9,"./types/600-034":10,"./types/600-035":11,"./types/600-036":12,"./types/600-037":13,"./types/600-038":14,"./types/600-039":15,"./types/600-232":16,"./types/600-233":17}],3:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_021 extends Device {
    constructor() {
        super("TX T&H AMB");

        this.PAYLOAD_LENGTH = 36;

        this.template.addValueField({
            temperature: {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            humidity: {
                unit: "%",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToUInt(hex, 10)),
            },
        });
        this.template.addValueField({
            voc: {
                unit: "ppb",
                value: template.templatedValue(20, 4, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            co2: {
                unit: "ppm",
                value: template.templatedValue(24, 4, parsers.hexToUInt),
            },
        });
        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(28, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(32, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(32, 4, parsers.hexToMsgType)
        });

    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature", values: [{ low: false }, { low: true }], bit: 2 },
            { name: "humidity", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "humidity", values: [{ low: false }, { low: true }], bit: 4 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_021;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],4:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_022 extends Device {
    constructor() {
        super("TX VOC/T&H AMB");

        this.PAYLOAD_LENGTH = 36;

        this.template.addValueField({
            temperature: {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            humidity: {
                unit: "%",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToUInt(hex, 10)),
            },
        });
        this.template.addValueField({
            voc: {
                unit: "ppb",
                value: template.templatedValue(20, 4, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            co2: {
                unit: "ppm",
                value: template.templatedValue(24, 4, parsers.hexToUInt),
            },
        });
        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(28, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(32, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(32, 4, parsers.hexToMsgType)
        });
        
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature", values: [{ low: false }, { low: true }], bit: 2 },
            { name: "humidity", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "humidity", values: [{ low: false }, { low: true }], bit: 4 },
            { name: "voc", values: [{ high: false }, { high: true }], bit: 5 },
            { name: "voc", values: [{ low: false }, { low: true }], bit: 6 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }


    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_022;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],5:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_023 extends Device {
    constructor() {
        super("TX CO2/VOC/T&H AMB");

        this.PAYLOAD_LENGTH = 36;

        this.template.addValueField({
            temperature: {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            humidity: {
                unit: "%",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToUInt(hex, 10)),
            },
        });
        this.template.addValueField({
            voc: {
                unit: "ppb",
                value: template.templatedValue(20, 4, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            co2: {
                unit: "ppm",
                value: template.templatedValue(24, 4, parsers.hexToUInt),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(28, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(32, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(32, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature", values: [{ low: false }, { low: true }], bit: 2 },
            { name: "humidity", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "humidity", values: [{ low: false }, { low: true }], bit: 4 },
            { name: "voc", values: [{ high: false }, { high: true }], bit: 5 },
            { name: "voc", values: [{ low: false }, { low: true }], bit: 6 },
            { name: "co2", values: [{ high: false }, { high: true }], bit: 7 },
            { name: "co2", values: [{ low: false }, { low: true }], bit: 8 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }


    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_023;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],6:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_024 extends Device {
    constructor() {
        super("TX CO2/T&H AMB");

        this.PAYLOAD_LENGTH = 36;

        this.template.addValueField({
            temperature: {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            }
        });
        this.template.addValueField({
            humidity: {
                unit: "%",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToUInt(hex, 10)),
            }
        });
        this.template.addValueField({
            voc: {
                unit: "ppb",
                value: template.templatedValue(20, 4, parsers.hexToUInt),
            }
        });
        this.template.addValueField({
            co2: {
                unit: "ppm",
                value: template.templatedValue(24, 4, parsers.hexToUInt),
            }
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(28, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(32, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(32, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature", values: [{ low: false }, { low: true }], bit: 2 },
            { name: "humidity", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "humidity", values: [{ low: false }, { low: true }], bit: 4 },
            { name: "co2", values: [{ high: false }, { high: true }], bit: 7 },
            { name: "co2", values: [{ low: false }, { low: true }], bit: 8 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }


    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_024;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],7:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_031 extends Device {
    constructor() {
        super("TX TEMP INS");

        this.PAYLOAD_LENGTH = 28;

        this.template.addValueField({
            "temperature_1": {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            "temperature_2": {
                unit: "°C",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        
        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(20, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(24, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(24, 4, parsers.hexToMsgType)
        });

    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature_1", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature_1", values: [{ low: false }, { low: true }], bit: 2 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_031;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],8:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_032 extends Device {
    constructor() {
        super("TX TEMP CONT1");

        this.PAYLOAD_LENGTH = 28;

        this.template.addValueField({
            "temperature_1": {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            "temperature_2": {
                unit: "°C",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(20, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(24, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(24, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature_1", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature_1", values: [{ low: false }, { low: true }], bit: 2 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_032;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],9:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_033 extends Device {
    constructor() {
        super("TX TEMP CONT1 MP");

        this.PAYLOAD_LENGTH = 28;

        this.template.addValueField({
            "temperature_1": {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            "temperature_2": {
                unit: "°C",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(20, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(24, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(24, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature_1", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature_1", values: [{ low: false }, { low: true }], bit: 2 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_033;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],10:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_034 extends Device {
    constructor() {
        super("TX T&H EXT");

        this.PAYLOAD_LENGTH = 28;

        this.template.addValueField({
            temperature: {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            humidity: {
                unit: "%",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToUInt(hex, 10)),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(20, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(24, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(24, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature", values: [{ low: false }, { low: true }], bit: 2 },
            { name: "humidity", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "humidity", values: [{ low: false }, { low: true }], bit: 4 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_034;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],11:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_035 extends Device {
    constructor() {
        super("TX 4/20mA");

        this.PAYLOAD_LENGTH = 24;

        this.template.addValueField({
            current: {
                unit: "mA",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToUInt(hex, 1000)),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(16, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(20, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(20, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "current", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "current", values: [{ low: false }, { low: true }], bit: 2 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_035;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],12:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_036 extends Device {
    constructor() {
        super("TX PULSE");

        this.PAYLOAD_LENGTH = 44;

        this.template.addValueField({
            "pulse_ch1": {
                unit: "count",
                value: template.templatedValue(12, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_ch2": {
                unit: "count",
                value: template.templatedValue(20, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_oc": {
                unit: "count",
                value: template.templatedValue(28, 8, parsers.hexToUInt),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(36, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(40, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField(template.templatedValue(40, 4, this.stateParser)); 
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "pulse_ch1_flow", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "pulse_ch2_flow", values: [{ high: false }, { high: true }], bit: 2 },
            { name: "pulse_oc_flow", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "pulse_ch1_flow", values: [{ low: false }, { low: true }], bit: 5 },
            { name: "pulse_ch2_flow", values: [{ low: false }, { low: true }], bit: 6 },
            { name: "pulse_oc_flow", values: [{ low: false }, { low: true }], bit: 7 },
            { name: "pulse_ch1_leak", values: [false, true], bit: 9 },
            { name: "pulse_ch2_leak", values: [false, true], bit: 10 },
            { name: "pulse_oc_leak", values: [false, true], bit: 11 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    stateParser(hexValue) {
        const defs = [
            { name: "msg_type", values: ["normal", "alarm"], bit: 1},
            { name: "pulse_ch1", values: ["open", "closed"], bit: 5 },
            { name: "pulse_ch2", values: ["open", "closed"], bit: 6 },
            { name: "pulse_oc", values: ["open", "closed"], bit: 7 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_036;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],13:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_037 extends Device {
    constructor() {
        super("TX PULSE ATEX");

        this.PAYLOAD_LENGTH = 44;

        this.template.addValueField({
            "pulse_ch1": {
                unit: "count",
                value: template.templatedValue(12, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_ch2": {
                unit: "count",
                value: template.templatedValue(20, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_oc": {
                unit: "count",
                value: template.templatedValue(28, 8, parsers.hexToUInt),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(36, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(40, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField(template.templatedValue(40, 4, this.stateParser));
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "pulse_ch1_flow", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "pulse_ch2_flow", values: [{ high: false }, { high: true }], bit: 2 },
            { name: "pulse_oc_flow", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "pulse_ch1_flow", values: [{ low: false }, { low: true }], bit: 5 },
            { name: "pulse_ch2_flow", values: [{ low: false }, { low: true }], bit: 6 },
            { name: "pulse_oc_flow", values: [{ low: false }, { low: true }], bit: 7 },
            { name: "pulse_ch1_leak", values: [false, true], bit: 9 },
            { name: "pulse_ch2_leak", values: [false, true], bit: 10 },
            { name: "pulse_oc_leak", values: [false, true], bit: 11 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    stateParser(hexValue) {
        const defs = [
            { name: "msg_type", values: ["normal", "alarm"], bit: 1},
            { name: "pulse_ch1", values: ["open", "closed"], bit: 5 },
            { name: "pulse_ch2", values: ["open", "closed"], bit: 6 },
            { name: "pulse_oc", values: ["open", "closed"], bit: 7 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_037;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],14:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_038 extends Device {
    constructor() {
        super("TX PULSE LED");

        this.PAYLOAD_LENGTH = 44;

        this.template.addValueField({
            "pulse_ch1": {
                unit: "count",
                value: template.templatedValue(12, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_ch2": {
                unit: "count",
                value: template.templatedValue(20, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_oc": {
                unit: "count",
                value: template.templatedValue(28, 8, parsers.hexToUInt),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(36, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(40, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField(template.templatedValue(40, 4, this.stateParser));
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "pulse_ch1_flow", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "pulse_ch2_flow", values: [{ high: false }, { high: true }], bit: 2 },
            { name: "pulse_oc_flow", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "pulse_ch1_flow", values: [{ low: false }, { low: true }], bit: 5 },
            { name: "pulse_ch2_flow", values: [{ low: false }, { low: true }], bit: 6 },
            { name: "pulse_oc_flow", values: [{ low: false }, { low: true }], bit: 7 },
            { name: "pulse_ch1_leak", values: [false, true], bit: 9 },
            { name: "pulse_ch2_leak", values: [false, true], bit: 10 },
            { name: "pulse_oc_leak", values: [false, true], bit: 11 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    stateParser(hexValue) {
        const defs = [
            { name: "msg_type", values: ["normal", "alarm"], bit: 1},
            { name: "pulse_ch1", values: ["open", "closed"], bit: 5 },
            { name: "pulse_ch2", values: ["open", "closed"], bit: 6 },
            { name: "pulse_oc", values: ["open", "closed"], bit: 7 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_038;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],15:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_039 extends Device {
    constructor() {
        super("TX CONTACT");

        this.PAYLOAD_LENGTH = 44;

        this.template.addValueField({
            "pulse_ch1": {
                unit: "count",
                value: template.templatedValue(12, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_ch2": {
                unit: "count",
                value: template.templatedValue(20, 8, parsers.hexToUInt),
            },
        });
        this.template.addValueField({
            "pulse_oc": {
                unit: "count",
                value: template.templatedValue(28, 8, parsers.hexToUInt),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(36, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(40, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField(template.templatedValue(40, 4, this.stateParser));
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "pulse_ch1", values: [{ change: false }, { change: true }], bit: 1 },
            { name: "pulse_ch2", values: [{ change: false }, { change: true }], bit: 2 },
            { name: "pulse_oc", values: [{ change: false }, { change: true }], bit: 3 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    stateParser(hexValue) {
        const defs = [
            { name: "msg_type", values: ["normal", "alarm"], bit: 1},
            { name: "pulse_ch1", values: ["open", "closed"], bit: 5 },
            { name: "pulse_ch2", values: ["open", "closed"], bit: 6 },
            { name: "pulse_oc", values: ["open", "closed"], bit: 7 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_039;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],16:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_232 extends Device {
    constructor() {
        super("TX TEMP CONT2");

        this.PAYLOAD_LENGTH = 28;

        this.template.addValueField({
            "temperature_1": {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            "temperature_2": {
                unit: "°C",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(20, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(24, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(24, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature_1", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature_1", values: [{ low: false }, { low: true }], bit: 2 },
            { name: "temperature_2", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "temperature_2", values: [{ low: false }, { low: true }], bit: 4 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_232;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],17:[function(require,module,exports){
const Device = require("./device/device").default;
const template = require("./../../tools/template").default;
const parsers = require("./../../tools/parsers");

class D600_233 extends Device {
    constructor() {
        super("TX TEMP CONT2 MP");

        this.PAYLOAD_LENGTH = 28;

        this.template.addValueField({
            "temperature_1": {
                unit: "°C",
                value: template.templatedValue(12, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });
        this.template.addValueField({
            "temperature_2": {
                unit: "°C",
                value: template.templatedValue(16, 4, (hex) => parsers.hexToInt(hex, 10)),
            },
        });

        this.template.setField(template.fields.ALARM_STATUS, template.templatedValue(20, 4, this.alarmParser));

        this.template.addStateField({
            battery: template.templatedValue(24, 4, parsers.hexToBatteryLvl),
        });
        this.template.addStateField({
            msg_type: template.templatedValue(24, 4, parsers.hexToMsgType)
        });
    }

    alarmParser(hexValue) {
        const defs = [
            { name: "temperature_1", values: [{ high: false }, { high: true }], bit: 1 },
            { name: "temperature_1", values: [{ low: false }, { low: true }], bit: 2 },
            { name: "temperature_2", values: [{ high: false }, { high: true }], bit: 3 },
            { name: "temperature_2", values: [{ low: false }, { low: true }], bit: 4 },
        ];

        return parsers.hexToStatus(hexValue, defs);
    }

    decode(payload) {
        return super.decode(payload, this.PAYLOAD_LENGTH);
    }
}

exports.device = D600_233;

},{"./../../tools/parsers":20,"./../../tools/template":21,"./device/device":18}],18:[function(require,module,exports){
const template = require("./../../../tools/template").default;

class Device {
    constructor(name) {
        this.name = name;
        this.template = template.create(name);
    }

    decode(payload, len) {
        if (payload.length === len) {
            return this.template.fill(payload);
        } else {
            return {
                result: null,
                error: `Invalid payload length. Received payload length: ${payload.length}. Expected payload length: ${len}`,
            };
        }
    }
}

exports.default = Device;

},{"./../../../tools/template":21}],19:[function(require,module,exports){
exports.INT_MIN = -parseInt("0xFFFF");
exports.INT_MAX = parseInt("0xFFFF");
},{}],20:[function(require,module,exports){
const consts = require("./constants");

exports.hexToUInt = (hex, divider = 1) => {
    return parseInt(hex, 16) / divider;
};

exports.hexToInt = (hex, divider = 1) => {
    const upperHex = hex.toUpperCase();

    if (upperHex >= "8000" && upperHex <= "FFFF") {
        return (parseInt(hex, 16) - consts.INT_MAX - 1) / divider;
    } else {
        return parseInt(hex, 16) / divider;
    }
};

exports.hexToBin = (hex, numOfBytes = 2) => {
    return parseInt(hex, 16)
        .toString(2)
        .padStart(numOfBytes * 4, "0");
};

exports.binToUInt = (bin) => {
    return parseInt(bin, 2);
};

exports.hexToFwVerison = (hex) => {
    const binNum = exports.hexToBin(hex);
    return exports.binToUInt(binNum.substring(binNum.length - 4, binNum.length));
};

exports.hexToStatus = (hex, defs) => {
    const status = {};
    const binNum = exports.hexToBin(hex, 4);

    defs.forEach((def) => {
        const bitValue = +binNum[binNum.length - def.bit];
        const textValue = def.values[bitValue];
        if (status.hasOwnProperty(def.name)) {
            status[def.name] = { ...status[def.name], ...textValue };
        } else {
            status[def.name] = textValue;
        }
    });
    return status;
};

exports.hexToBatteryLvl = (hex, startBit = 4, endBit = 2) => {
    const binNum = exports.hexToBin(hex, 4);
    const batteryCode = binNum.substring(binNum.length - startBit, binNum.length - endBit);

    switch (batteryCode) {
        case "00":
            return "100%";
        case "01":
            return "75%";
        case "10":
            return "50%";
        case "11":
            return "25%";
        default:
            return "unknown";
    }
};

exports.hexToMsgType = (hex, bit = 1) => {
    const binNum = exports.hexToBin(hex, 4);
    const bitValue = +binNum[binNum.length - bit];
    if(bitValue) return "alarm";
    else return "normal";
};

},{"./constants":19}],21:[function(require,module,exports){
const parsers = require("./parsers");

class Template {
    constructor(name = "") {
        this.name = name;
        this.template = {
            id: new TemplatedValue(0, 6, parsers.hexToUInt),
            type: new TemplatedValue(6, 2, parsers.hexToUInt),
            seq_counter: new TemplatedValue(8, 2, parsers.hexToUInt),
            fw_version: new TemplatedValue(10, 2, parsers.hexToFwVerison),
            values: [],
            alarm_status: {},
            states: [],
        };
        this.supportedFields = Object.keys(this.template);
    }

    setField(field, value) {
        if (this.supportedFields.includes(field) && value instanceof TemplatedValue) {
            this.template[field] = value;
        } else {
            console.log(`Field: ${field} is invalid or the inserted value is not of required type.`);
        }
    }

    addValueField(valueDefinition) {
        this.template.values.push(valueDefinition);
    }
    addStateField(stateDefinition) {
        this.template.states.push(stateDefinition);
    }

    fill(data) {
        if(!Boolean(data.match(/^[0-9a-f]+$/i))){
            return{
                result: null,
                error: "Invalid payload. Only hexadecimal digits are allowed."
            };
        }
        const filledTemplate = {};

        const parseField = (field) => {
            if (typeof field === "object" && !(field instanceof TemplatedValue)) {
                let completeField = { ...field };
                for (const key in field) {
                    completeField[key] = parseField(field[key]);
                }
                return completeField;
            } else if (field instanceof TemplatedValue) {
                const evalutedTemplateValue = field.evaluate(data);

                if (evalutedTemplateValue.error) throw new Error("invalid template");
                else return evalutedTemplateValue.result;
            } else {
                return field;
            }
        };

        try {
            for (const field in this.template) {
                if (Array.isArray(this.template[field])) {
                    filledTemplate[field] = [];

                    this.template[field].forEach((arrField) => {
                        filledTemplate[field] = { ...filledTemplate[field], ...parseField(arrField) };
                    });
                } else {
                    filledTemplate[field] = parseField(this.template[field]);
                }
            }

            if (this.name) filledTemplate.type += " - " + this.name;
            return {
                result: filledTemplate,
                error: null,
            };
        } catch (e) {
            return {
                result: null,
                error: e.message,
            };
        }
    }
}

class TemplatedValue {
    constructor(start, len, parser) {
        this.start = start;
        this.len = len;
        this.parser = parser;
    }

    evaluate(hex) {
        if (isFinite(this.start) && isFinite(this.len) && this.len > 0 && this.parser && typeof this.parser === "function") {
            const dataForParser = hex.substr(this.start, this.len);
            return {
                result: this.parser(dataForParser),
                error: null,
            };
        } else {
            return {
                result: null,
                error: "Invalid templated value. Value could not be evaluated",
            };
        }
    }
}

exports.default = {
    create: (name) => new Template(name),
    templatedValue: (start, len, parser) => new TemplatedValue(start, len, parser),
    fields: {
        ID: "id",
        TYPE: "type",
        SEQ_NUMBER: "seq_number",
        METADATA: "metadata",
        ALARM_STATUS: "alarm_status",
        STATUS: "status",
    },
};

},{"./parsers":20}],22:[function(require,module,exports){
const  codec = require("./../../index.js");

//const dropDown = document.querySelector(".typeDropDown");
const dropDownList = document.querySelector(".dropDownList");
const dropDownInput = document.querySelector(".typeInput");
const payloadInput = document.querySelector(".payloadInput");
const decodeButton = document.querySelector(".decodeButton");
const resultArea = document.querySelector(".resultArea");

let selectedType = null;

const deviceTypes = [
    {
        id: "600-021",
        name: "TX T&H AMB",
        defaultPayload: "00006D04130100E501200000000000080000"
    },
    {
        id: "600-022",
        name: "TX VOC/T&H AMB",
        defaultPayload: "00007705110100E3011F0014000000280000"
    },
    {
        id: "600-023",
        name: "TX CO2/VOC/T&H AMB",
        defaultPayload: "000081060E1100D3016500AD026100800000"
    },
    {
        id: "600-024",
        name: "TX CO2/T&H AMB",
        defaultPayload: "0000810E0E1100D301650000026100800000"
    },
    {
        id: "600-031",
        name: "TX TEMP INS",
        defaultPayload: "00008A07070100CD000000020000"
    },
    {
        id: "600-032",
        name: "TX TEMP CONT1",
        defaultPayload: "0000DC0F0A0100D0000000000000"
    },
    {
        id: "600-033",
        name: "TX TEMP CONT1 MP",
        defaultPayload: "0000DC100A0100D0000000000000"
    },
    {
        id: "600-034",
        name: "TX T&H EXT",
        defaultPayload: "0000D10E0A0100CA018200010000"
    },
    {
        id: "600-035",
        name: "TX 4/20mA",
        defaultPayload: "0000C70D0A01000200020000"
    },
    {
        id: "600-036",
        name: "TX PULSE",
        defaultPayload: "000095080C0100000020000000170000001E00000000"
    },
    {
        id: "600-037",
        name: "TX PULSE ATEX",
        defaultPayload: "0000A0090D01000000120000001A0000001800000000"
    },
    {
        id: "600-038",
        name: "TX PULSE LED",
        defaultPayload: "0000AA0A0D0100000000000000000000000A00000060"
    },
    {
        id: "600-039",
        name: "TX CONTACT",
        defaultPayload: "0000B40B0E0100000018000000280000005600040001"
    },
    {
        id: "600-232",
        name: "TX TEMP CONT2",
        defaultPayload: "0000BD0C0A0100CE00CA00010000"
    },
    {
        id: "600-233",
        name: "TX TEMP CONT2 MP",
        defaultPayload: "0000BD110A0100CE00CA00010000"
    }
];

selectedType = deviceTypes[0];

payloadInput.value = selectedType.defaultPayload;
dropDownInput.value = createLabel(selectedType);
dropDownInput.addEventListener("click", () => {
    dropDownList.classList.toggle("show");
});

for (const type in deviceTypes) {
    dropDownList.innerHTML += `<li>${createLabel(deviceTypes[type])}</li>`
}

document.querySelectorAll("li").forEach(li => {
    li.addEventListener("click", e => {
        const devInfo = e.target.innerText.trim();
        const name = devInfo.substring(0, devInfo.indexOf(" 600"));
        const id = devInfo.substring(devInfo.indexOf("600"), devInfo.length);

        selectedType = deviceTypes.filter(type => type.id === id && type.name === name);

        dropDownInput.value = createLabel(selectedType[0]);
        payloadInput.value  = selectedType[0].defaultPayload;
    });
});

decodeButton.addEventListener("click", () => {
    const val = dropDownInput.value;
    const type = val.substring(val.indexOf("600"), val.length);
    const payload = payloadInput.value.trim();
    const Decoder = new codec.Decoder(type);
    const decodedData = Decoder.decode(payload);

    if(decodedData.error){
        resultArea.value = JSON.stringify(decodedData.error);
    }else{
        resultArea.value = JSON.stringify(decodedData.result, null, 2);
    }
});


window.onclick = function (event) {
    if (!event.target.matches('.typeInput')) {
        let dropdowns = document.getElementsByClassName("dropDownList");
        let i;
        for (i = 0; i < dropdowns.length; i++) {
            let openDropdown = dropdowns[i];
            if (openDropdown.classList.contains('show')) {
                openDropdown.classList.remove('show');
            }
        }
    }
}


function createLabel (devType) {
    return devType.name + " " + devType.id;
}


},{"./../../index.js":1}]},{},[22]);
